## Turn off meaningless jar repackaging on SL6
%define __jar_repack 0

Name: canl-java-tomcat

Version: 0.1.18
Release: 1%{?dist}
Summary: EMI Common Authentication Library Tomcat plugin

Group: System Environment/Libraries
License: ASL 2.0
URL: https://twiki.cern.ch/twiki/bin/view/EMI/CANLTomcatPlugin
Packager: Joni Hahkala <joni.hahkala@cern.ch>

Source: %{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

BuildRequires: java-devel
BuildRequires: maven

%if 0%{?el6}
Requires: tomcat6
%else
Requires: tomcat5
%endif 

Requires: java
Requires: canl-java

%description 
Plugin that allows the use of EMI Common Authentication Library in tomcat.

%prep
%setup -q

%build
export JAVA_HOME=/usr/lib/jvm/java
make package

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_datadir}/java
%{_datadir}/java/%{name}.jar
%{_datadir}/java/%{name}-%{version}.jar
%doc README.md doc/RELEASE-NOTES doc/COPYRIGHT doc/LICENSE doc/USAGE

%post
if [ x%{?dist} == x.el6 ]; then
	tomcat_ver=tomcat6
else
	tomcat_ver=tomcat5
fi	
# TODO: remove the -new ending form the link names after it's sure people have migrated from 0.1.12 
# version. Add removal of the -new named link to the post target to remove the old links when doing so.
if [ ${tomcat_ver}x == "tomcat5x" ] ; then
	ln -snf %{_datadir}/java/%{name}.jar /var/lib/tomcat5/server/lib/%{name}-new.jar
	# in sl5 we use emi distributed bouncycastle as the system one is too old for canl
	if [ -f /usr/share/java/bcprov-1.46.jar ] ; then 
		ln -snf /usr/share/java/bcprov-1.46.jar /var/lib/tomcat5/server/lib/bcprov-new.jar
	else
		echo /usr/share/java/bcprov-1.46.jar not found, cannot link it to the tomcat server/lib
	fi
	if [ -f /usr/share/java/commons-io.jar ] ; then 
		ln -snf /usr/share/java/commons-io.jar /var/lib/tomcat5/server/lib/commons-io-new.jar
	else
		echo /usr/share/java/commons-io.jar not found, cannot link it to the tomcat server/lib
	fi
	# search for versioned canl jar, as no unversioned one exists at the moment.
	canl_jar=`ls /usr/share/java/canl-* |grep "canl-[0-9\.].*\.jar"`
	if [ -f /usr/share/java/canl.jar ] ; then 
		ln -snf /usr/share/java/canl.jar /var/lib/tomcat5/server/lib/canl-new.jar
	elif [ -f ${canl_jar} ] ; then 
		ln -snf ${canl_jar} /var/lib/tomcat5/server/lib/canl-new.jar
	else
		echo /usr/share/java/canl.jar not found, cannot link it to the tomcat server/lib
	fi
elif [ ${tomcat_ver}x == "tomcat6x" ] ; then
	ln -snf %{_datadir}/java/%{name}.jar /usr/share/tomcat6/lib/%{name}-new.jar
	if [ -f /usr/share/java/bcprov.jar ] ; then 
		ln -snf /usr/share/java/bcprov.jar /usr/share/tomcat6/lib/bcprov-new.jar
	else
		echo "/usr/share/java/bcprov.jar not found, cannot link it to the tomcat server/lib"
	fi
	if [ -f /usr/share/java/commons-io.jar ] ; then 
		ln -snf /usr/share/java/commons-io.jar /usr/share/tomcat6/lib/commons-io-new.jar
	else
		echo "/usr/share/java/commons-io.jar not found, cannot link it to the tomcat server/lib"
	fi
	canl_jar=`ls /usr/share/java/canl-* |grep "canl-[0-9\.].*\.jar"`
	if [ -f /usr/share/java/canl.jar ] ; then 
		ln -snf /usr/share/java/canl.jar /usr/share/tomcat6/lib/canl-new.jar
	elif [ -f ${canl_jar} ] ; then 
		ln -snf ${canl_jar} /usr/share/tomcat6/lib/canl-new.jar
	else
		echo /usr/share/java/canl.jar not found, cannot link it to the tomcat server/lib
	fi
else
	echo "invalid tomcat setting "${tomcat_ver}", not linking jars to it's server/lib" >&2
fi


%postun
if [ "$1" = "0" ] ; then 
	if [ x%{?dist} != x.el6 ] ; then
		rm -f /var/lib/tomcat5/server/lib/%{name}-new.jar
		rm -f /var/lib/tomcat5/server/lib/bcprov-new.jar
		rm -f /var/lib/tomcat5/server/lib/commons-io-new.jar
		rm -f /var/lib/tomcat5/server/lib/canl-new.jar
	elif [ x%{?dist} == x.el6 ] ; then
		rm -f /usr/share/tomcat6/lib/%{name}-new.jar
		rm -f /usr/share/tomcat6/lib/bcprov-new.jar
		rm -f /usr/share/tomcat6/lib/commons-io-new.jar
		rm -f /usr/share/tomcat6/lib/canl-new.jar
	fi
fi


%changelog
* Tue Sep 16 2013 Joni Hahkala <joni.hahkala@cern.ch> 0.1.18-1
- Bug fix for preun removing links during upgrade, changed to postun and only run when
  last version is removed. Change the name of links as the old version removes the old
  named links.
- fix debian installation

* Tue Dec 01 2012 Joni Hahkala <joni.hahkala@cern.ch> 0.1.13-1
- Bug fix for hanging connections, as handshake is forced in accept. Stop forcing it.

* Tue Dec 01 2012 Joni Hahkala <joni.hahkala@cern.ch> 0.1.12-1
- Initial release


